require 'rake/testtask'
require "bundler/gem_tasks"
Rake.application.instance_variable_get('@tasks').delete('release')

desc 'Run test_unit based test'
task :test do
  Dir.glob('test/**/test_*.rb') do |path|
    cmd = "bundle exec ruby #{path}"
    puts cmd
    system cmd
  end
end

%w(example example_dev).each do |base_dir_name|

  example_dests = []
  directory "#{base_dir_name}/"
  Dir.glob("#{base_dir_name}_src/**/*.rb") do |src|
    # サブディレクトリを持っているかどうかで処理を分岐
    dest_dir = "#{base_dir_name}/"
    if src =~ %r|/.+?/| then
      dest_dir = File.dirname(src).sub(/^example_src/, 'example')
    end

    # 出力先を取得
    dest = src.sub(/^#{base_dir_name}_src/, base_dir_name)
    example_dests << dest

    # タスク定義
    directory dest_dir
    desc '-'
    file dest => [src, dest_dir, __FILE__] + FileList['lib/**/*.rb'] do
      # NeuronCheckを使用してスクリプト実行
      cmd = %Q|bundle exec ruby -I lib #{src}|
      puts cmd
      system cmd, [:out, :err] => ['_example_out.txt', 'w']

      # スクリプトの実行の結果、出力された内容を、コメントとして後ろに結合したうえで書き込む
      # ただしこの際、ファイルパスを置換するなどの加工もかける
      output_lines = File.readlines('_example_out.txt')
      output = output_lines.map{|x| "#   #{x}"}.join.sub('#  ', '#=>')
      output.gsub!(Dir.pwd, '.')
      output.gsub!(src, 'script.rb')

      File.write(dest, File.read(src) + "\n" + output)
      $stderr.puts "-> #{dest}"
    end
  end


  desc 'make example code'
  task base_dir_name => example_dests

end
